//
//  MainViewController.m
//  Weather
//
//  Created by Alasdair Allan on 29/08/2009.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "MainViewController.h"
#import "MainView.h"
#import "WeatherForecast.h"
#import "WeatherAppDelegate.h"

@implementation MainViewController

@synthesize forecast;
@synthesize loadingActivityIndicator;
@synthesize location;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad {
	[super viewDidLoad];
	location = [[NSString alloc] init];
	[self refreshView:self];
}


- (IBAction)refreshView:(id)sender {
	[loadingActivityIndicator startAnimating];
	
	WeatherAppDelegate *appDelegate = (WeatherAppDelegate *)[[UIApplication sharedApplication] delegate];
    if( appDelegate.updateLocation ) {
		NSLog( @"updating for location = %@", self.location );
		[forecast queryService:self.location withParent:self];

	} else {
		[forecast queryService:@"London,UK" withParent:self];

	}
		
}

- (void)updateView {
	
	// City Info
	nameLabel.text = forecast.location;
	dateLabel.text = forecast.date;
	
	// Now
	nowTempLabel.text = forecast.temp;
	nowHumidityLabel.text = forecast.humidity;
	nowWindLabel.text = forecast.wind;
	nowConditionLabel.text = forecast.condition;
	NSURL *url = [NSURL URLWithString:(NSString *)forecast.icon];
	NSData *data = [NSData dataWithContentsOfURL:url];
	nowImage.image = [[UIImage alloc] initWithData:data];
	
	// Day 1
	dayOneLabel.text = [forecast.days objectAtIndex:0];
	dayOneTempLabel.text = [forecast.temps objectAtIndex:0];
	dayOneChanceLabel.text = [forecast.conditions objectAtIndex:0];
	url = [NSURL URLWithString:(NSString *)[forecast.icons objectAtIndex:0]];
	data = [NSData dataWithContentsOfURL:url];
	dayOneImage.image = [[UIImage alloc] initWithData:data];

	// Day 2
	dayTwoLabel.text = [forecast.days objectAtIndex:1];
	dayTwoTempLabel.text = [forecast.temps objectAtIndex:1];
	dayTwoChanceLabel.text = [forecast.conditions objectAtIndex:1];
	url = [NSURL URLWithString:(NSString *)[forecast.icons objectAtIndex:1]];
	data = [NSData dataWithContentsOfURL:url];
	dayTwoImage.image = [[UIImage alloc] initWithData:data];

	// Day 3
	dayThreeLabel.text = [forecast.days objectAtIndex:2];
	dayThreeTempLabel.text = [forecast.temps objectAtIndex:2];
	dayThreeChanceLabel.text = [forecast.conditions objectAtIndex:2];
	url = [NSURL URLWithString:(NSString *)[forecast.icons objectAtIndex:2]];
	data = [NSData dataWithContentsOfURL:url];
	dayThreeImage.image = [[UIImage alloc] initWithData:data];
	
	// Day 4
	dayFourLabel.text = [forecast.days objectAtIndex:3];
	dayFourTempLabel.text = [forecast.temps objectAtIndex:3];
	dayFourChanceLabel.text = [forecast.conditions objectAtIndex:3];
	url = [NSURL URLWithString:(NSString *)[forecast.icons objectAtIndex:3]];
	data = [NSData dataWithContentsOfURL:url];
	dayFourImage.image = [[UIImage alloc] initWithData:data];
	
	[loadingActivityIndicator stopAnimating];
	
}


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */


- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller {
    
	[self dismissModalViewControllerAnimated:YES];
}


- (IBAction)showInfo {    
	
	FlipsideViewController *controller = [[FlipsideViewController alloc] initWithNibName:@"FlipsideView" bundle:nil];
	controller.delegate = self;
	
	controller.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
	[self presentModalViewController:controller animated:YES];
	
	[controller release];
}


/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[location release];
	
	[nameLabel release];
	[dateLabel release];
	
	[nowImage release];
	[nowTempLabel release];
	[nowHumidityLabel release];
	[nowWindLabel release];
	
	[dayOneLabel release];
	[dayOneImage release];	
	[dayOneTempLabel release];
	[dayOneChanceLabel release];
	
	[dayTwoLabel release];
	[dayTwoImage release];	
	[dayTwoTempLabel release];
	[dayTwoChanceLabel release];	
	
	[dayThreeLabel release];
	[dayThreeImage release];	
	[dayThreeTempLabel release];
	[dayThreeChanceLabel release];
	
	[dayFourLabel release];
	[dayFourImage release];	
	[dayFourTempLabel release];
	[dayFourChanceLabel release];	
	
	[refreshButton release];
	
	[forecast release];
    [super dealloc];
}


@end
